using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Runtime.Serialization;
using System.Runtime.Serialization.Formatters.Binary;
using System.IO;


namespace WindowsApplication1
{
    public partial class Form2 : Form
    {
        public string FileName;
        List<Figure> array; 
        Boolean b,
        iz;
        Point po1 = new Point();
        Point po2 = new Point();
        Rect f = new Rect();
        Form1 frm1;

        public void save()
        {
            BinaryFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream(FileName, FileMode.Create, FileAccess.Write, FileShare.None);
            formatter.Serialize(stream, array);
            stream.Close();
            iz = false;
            this.Text = FileName;
            frm1.hidesave();
            frm1.hidesaveas();
        }
        public void paste()
        {
            BinaryFormatter formatter = new BinaryFormatter();
            Stream stream = new FileStream(FileName, FileMode.Open, FileAccess.Read, FileShare.Read);
            array = (List<Figure>)formatter.Deserialize(stream);
            stream.Close();
            Invalidate();
            iz = false;
            this.Text = FileName;
        }
            public Form2()
        {
            InitializeComponent();
            Graphics g = CreateGraphics();
        }
        private void Form2_MouseDown(object sender, MouseEventArgs e)
        {
                po1 = new Point(e.X,e.Y); 
        }


        private void Form2_MouseMove(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                b = true;
                if (FileName != null)
                {
                    this.Text = FileName + "*";
                    frm1.showsaveas();
                    frm1.showsave();
                }
                else
                {
                    frm1.showsaveas();
                    frm1.hidesave();
                }
                iz = true;
                po2 = new Point(e.X,e.Y);
                f = new Rect(po1, po2);
                Graphics g = CreateGraphics();
                f.DrawDash(g);
                Invalidate();
            }           
        }


        private void Form2_MouseUp(object sender, MouseEventArgs e)
        {
            array.Add(f); 
            Invalidate();
            b = false;
        }

        private void Form2_Load(object sender, EventArgs e)
        {
            array = new List<Figure>();
            iz = false;
            frm1 = (Form1)ParentForm;
        }

        private void Form2_Paint(object sender, PaintEventArgs e)
        {
            foreach (Figure f in array) f.Draw(e.Graphics);
            if (b) { f.DrawDash(e.Graphics); }
        }

        private void Form2_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (iz)
            {
                DialogResult dr = MessageBox.Show(" , ?", "", MessageBoxButtons.YesNoCancel);
                if (dr == DialogResult.Yes)
                {
                    if (FileName == null)
                    {
                        frm1.showdialogsave();
                        frm1.hidesave();
                    }
                    else
                    {
                       save();
                    }        
                }
                if (dr == DialogResult.No)
                {      
                }
                if (dr == DialogResult.Cancel) 
                {
                    e.Cancel = true;
                }
                frm1.hidesave();
                frm1.hidesaveas();
            }
        }

        private void Form2_Activated(object sender, EventArgs e)
        {
            if (iz)
            {
                if (FileName == null) { frm1.showsaveas(); frm1.hidesave(); }
            }
            else
            {
                frm1.hidesaveas();
                frm1.hidesave();
            }
        }
    }
}

