using System;
using System.Collections.Generic;
using System.Text;
using WindowsApplication1;
using System.Drawing;
using System.Windows.Forms;


namespace WindowsApplication1
{
    public abstract class Figure
    {
        //int flag, oldX, oldY, X1, X2, Y1, Y2;
        public Rectangle getRect()
        {
            int X1, X2, Y1, Y2;
            
                X1 = point1.X < point2.X ? point1.X : point2.X;
                X2 = point1.X < point2.X ? point2.X : point1.X;
                Y1 = point1.Y < point2.Y ? point1.Y : point2.Y;
                Y2 = point1.Y < point2.Y ? point2.Y : point1.Y;
                return new Rectangle(new Point(X1,Y1),new Size(X2-X1,Y2-Y1));    
         }
            
        //public void norm(ref int X1, ref int Y1, ref int X2, ref int Y2) { }
        public Point point1, point2;
        public Figure(Point point1, Point point2) { this.point1 = point1; this.point2 = point2; }        
        public abstract void Draw(Graphics g, Pen pen);
        public abstract void DrawDash(Graphics g, Pen pen);
        public abstract void Hide(Graphics g, Pen pen);
        public void Resize(Point p)
        {
            point2 = p;
        }

    }
    public class Rect : Figure
    {
       // public Rectengle() { }
        public Rect(Point point1, Point point2) : base(point1, point2) { }        
        public override void Draw(Graphics g, Pen pen) 
        {
            //int x1 = point1.X, y1 = point1.Y;
            //int x2 = point2.X, y2 = point2.Y;
            //g.Clear(Color.White);
            //Rectangle r = Rectangle.FromLTRB(point1.X = x1, point1.Y = y1, point2.X = x2, point2.X = y2);
            //g.FillRectangle(Brushes.White, r);
            g.DrawRectangle(pen, getRect());
        }
        public override void DrawDash(Graphics g, Pen pen) { }
        public override void Hide(Graphics g, Pen pen) { }
    }
}
