﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace WindowsApplication1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
        void NewForm()
        {
            Form frm = new Form2();
            frm.MdiParent = this;
            frm.Text = "Рисунок " + this.MdiChildren.Length.ToString();
            frm.Show();
        }
        public void hidesave() 
        {
            saveToolStripMenuItem.Enabled = false;
        }
        public void hidesaveas()
        {
            saveAsToolStripMenuItem.Enabled = false;
        }
        public void showsave()
        {
            saveToolStripMenuItem.Enabled = true;
        }
        public void showsaveas()
        {
            saveAsToolStripMenuItem.Enabled = true;
        }
        public void showdialogsave() 
        {
            saveFileDialog1.InitialDirectory = Environment.CurrentDirectory;
            saveFileDialog1.ShowDialog();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form1.ActiveForm.Close();
        }

        private void newToolStripMenuItem_Click(object sender, EventArgs e)
        {
            NewForm();
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            Form about = new Form3();
            about.Show(); 
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            openFileDialog1.ShowDialog();
        }

        private void openFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            NewForm();
            Form2 frm2 = (Form2)this.ActiveMdiChild;
            frm2.FileName = openFileDialog1.FileName;
            frm2.paste(); 
        }

        private void saveToolStripMenuItem_Click(object sender, EventArgs e)
        { 
            Form2 frm2 = (Form2)this.ActiveMdiChild;
            frm2.save(); 
        }

        private void saveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            saveFileDialog1.InitialDirectory=Environment.CurrentDirectory;
            saveFileDialog1.ShowDialog();   
        }
        
        private void saveFileDialog1_FileOk(object sender, CancelEventArgs e)
        {
            Form2 frm2 = (Form2)this.ActiveMdiChild;
            frm2.FileName = saveFileDialog1.FileName;
            frm2.save();
        }

        private void mnuArrangeIcons_Click(object sender, System.EventArgs e)
        {
            this.LayoutMdi(MdiLayout.ArrangeIcons);
        }

        private void cascadeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.Cascade);
        }

        private void tileHorizontalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileHorizontal);
        }

        private void tileVerticalToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.LayoutMdi(MdiLayout.TileVertical);
        }       
    }
}